import "./localStorage";

import { init, initializeDeviceLogin, finalizeDeviceLogin, credentialsProvider } from "@tidal-music/auth";

const clientId = "zU4XHVVkc2tDPo4t";
const clientSecret = "VJKhDFqJPqvsPVNBV6ukXTJmwlvbttP7wlMlrc72se4=";

export default async () => {
    await init({
        clientId,
        clientSecret,
        credentialsStorageKey: "tidal-credentials",
        scopes: ["r_usr", "w_usr", "w_sub"],
    })

    const credentials = await credentialsProvider.getCredentials();

    if (typeof credentials.userId !== "string" || (credentials.expires || 0) < Date.now()) {

        const response = await initializeDeviceLogin();

        console.log(`Please open https://${response.verificationUriComplete} to login.`)

        await finalizeDeviceLogin();
    }

    return {
        "Authorization": `Bearer ${(await credentialsProvider.getCredentials()).token || ""}`
    }
}